!
subroutine LA12(A, AF, T, B, Eps, Max, X, Error)
!     Ax=b    A,
!    LA10
!declaration
real, intent(in):: A(:,:), AF(:,:), B(:), Eps
integer, intent(in):: T(:)
integer, intent(inout):: Max
real:: X(:)
integer:: Error
real, parameter:: kof=0.5
real, allocatable:: R(:)
real SX, SR, SRp
double precision Sum
integer i, j, p, m, N
!begin
  N=size(A,1)
  allocate(R(N))
  X=B; p=0
  do i=1, N
    m=T(i)
    Sum=dble(X(m)); X(m)=X(i)
    do j=1, i-1
      Sum=Sum-AF(i,j)*dble(X(j))
    end do
    X(i)=sngl(Sum)
  end do
  do i=N, 1, -1
    Sum=dble(X(i))
    do j=i+1, N
      Sum=Sum-AF(i,j)*dble(X(j))
    end do
    X(i)=sngl(Sum/AF(i,i))
  end do
!  
10  continue
    do i=1, N
      Sum=B(i)
      do j=1, N
        Sum=Sum-A(i,j)*dble(X(j))
      end do
      R(i)=sngl(Sum)
    end do
    do i=1, N
      m=T(i)
      Sum=dble(R(m)); R(m)=R(i)
      do j=1, i-1
        Sum=Sum-AF(i,j)*dble(R(j))
      end do
      R(i)=sngl(Sum)
    end do
    do i=N, 1, -1
      Sum=dble(R(i))
      do j=i+1, N
        Sum=Sum-AF(i,j)*dble(R(j))
      end do
      R(i)=sngl(Sum/AF(i,i))
    end do
    do i=1, N
      if (abs(R(i))>Eps*abs(X(i))) goto 15
    end do
    deallocate(R)
    Max=p; Error=0; return
15  continue
    SR=0.0; SX=0.0
    do i=1, N
      SR=SR+abs(R(i)); SX=SX+abs(X(i))
    end do
    if (SR<Eps*SX) then
      deallocate(R)
      Max=p; Error=1; return
    end if
    if (p>0) then
      if (SR>kof*SRp) then
        deallocate(R)
        Max=p; Error=2
        if (p<=1) Error=65
        return
      end if
    end if
    SRp=SR; X=X+R; p=p+1
  if (p<Max) goto 10
  deallocate(R)
  Error=3; return
end subroutine LA12
